#include "GenotypeDecoder.h"
#include "Controller.h"
#include "../ga/Genome.h"
#include "../ga/ValueGenome.h"
#include "nn/GraphNeuralNetwork.h"

/*!	\file GenotypeDecoder.cpp
	\brief Implementation of generic genotype decoders methods
*/

namespace Teem
{
	DummyGenotypeDecoder::DummyGenotypeDecoder(const std::string &root)
		: GenotypeDecoder(root)
	{ }

	Genome* DummyGenotypeDecoder::createGenome(void)
	{
		// Create genome
		Genome* genome = Genome::create(Genome::BIT_GENOME, genomeLength);
		genome->randomize();
		return genome;
	}
}

