#ifndef __JOYSTICK_CONTROLLER_H
#define __JOYSTICK_CONTROLLER_H

#ifdef HAVE_VIEWER

#include "Controller.h"

/*!	\file Joystick.h
	\brief Interface of the Joystick Controller
*/


//! Maximum number of supported buttons on the joystick
#define JOYSTICK_NB_BUTTONS 8

struct _SDL_Joystick;

namespace Teem
{
	//! A controller that allows the user to control the robot with a joystick. Very useful for testing. 
	//! \ingroup controllers
	class JoystickController : public Controller
	{
	public:
		//! Constructor, initialise joystick
		JoystickController();
		virtual ~JoystickController();
		
		//! set values gotten from joystick
		virtual void setInput(unsigned index, double val)
		{
			assert(false);
		}
		
		//! get info from the joystick
		virtual double getOutput(unsigned index)
		{
// 			assert(index < 4);
			return output[index];
		}
		
		virtual void step();
		
		//! Return true if button is pressed
		bool isButtonDown(unsigned button);
		
	protected:
		double output[JOYSTICK_NB_BUTTONS]; //!< values of buttons
		struct _SDL_Joystick *joy; //!< pointer to SDL's joystick
	};
}

#endif // HAVE_VIEWER

#endif
