// (c) 2004 Stephane Magnenat, this code is GPL

#ifndef __VIDEOREC_H
#define __VIDEOREC_H

#ifdef HAVE_AVCODEC

//! Helper class to record a video using libavcodec
class VideoRecorder
{
public:
	//! Constructor
	VideoRecorder();
	//! Destructor
	~VideoRecorder();
	//! Open a file for recording. Initialise the video recorder
	//! @param filename Name of file to record to
	//! @param width Width of video in pixel
	//! @param height Height of video in pixel
	//! @param rate Bitrate to use to encode video
	void openFile(const char *filename, int width, int height, int rate = 1000000);
	//! Encode frame
	//! @param data pointer from where to get frame to encode. Length of data must be width*height*4 where width and height and dimension of video declared in openFile. Data are 32 bits RGBA
	void encodeFrame(unsigned char *data);
	//! Stop recording to file
	void closeFile();
};

#endif // HAVE_AVCODEC

#endif
