#ifndef __REGISTRATION_H
#define __REGISTRATION_H

#include "../utils/Registrar.h"

/*!	\file Registry.h
	\brief Definition of all libraries
*/

namespace Teem
{
	class EvolutionRun;
	class Experiment;
	class Neuron;
	class Synapse;
	class GenotypeDecoder;
	
	//! Library of all available evolutions
	extern Registrar<EvolutionRun, std::string> *evolutionsLibrary;
	//! Library of all available experiment
	extern Registrar<Experiment, std::string> *experimentsLibrary;
	//! Library of all available neurons
	extern Registrar<Neuron, std::string> *neuronsLibrary;
	//! Library of all available synapses
	extern Registrar<Synapse, std::string> *synapsesLibrary;
	//! Library of all available genotype decoders
	extern Registrar<GenotypeDecoder, std::string, const std::string&> *genotypeDecodersLibrary;
	
	//! Create libraries and populate them
	void initRegistry(void);
	//! Destroy libraries
	void destroyRegistry(void);
}

#endif
