/*
  This code has been taken from Globulation 2 (http://glob2.ysagoon.com)
  
  Copyright (C) 2001-2005 Stephane Magnenat & Luc-Olivier de Charrière
  for any question or comment contact us at nct@ysagoon.com or nuage@ysagoon.com

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include "VFS.h"

// include for file operations
#ifdef WIN32
#	include <windows.h>
#	include <io.h>
#	include <direct.h>
#else
#	include <sys/types.h>
#	include <dirent.h>
#	include <sys/stat.h>
#endif

/*
// package and data dir
#ifndef PACKAGE_DATA_DIR
	#define PACKAGE_DATA_DIR ".."
#endif

#ifndef PACKAGE_SOURCE_DIR
	#define PACKAGE_SOURCE_DIR "../.."
#endif
*/

/*!	\file VFS.cpp
	\brief Implementation of a simple virtual filesystem
*/

namespace Teem
{
	VFS vfs;
	
	VFS::VFS(/*const std::string &applicationName*/)
	{
	/*	#ifndef WIN32
		std::string applicationLocal(getenv("HOME"));
		applicationLocal += "/.";
		applicationLocal += applicationName;
		mkdir(applicationLocal.c_str(), S_IRWXU);
		addDir(applicationLocal.c_str());
		addDir(PACKAGE_DATA_DIR);
		addDir(PACKAGE_SOURCE_DIR);
		#endif
		addDir(".");
	*/
	}
	
	VFS::~VFS()
	{
		dirList.clear();
	}
	
	void VFS::addDir(const std::string &dir)
	{
		dirList.push_back(dir);
	}
	
	void VFS::addWriteSubdir(const std::string &subdir)
	{
		// we create subdir for the first index
		std::string toCreate(dirList[0]);
		toCreate += '/';
		toCreate += subdir;
		#ifdef WIN32
		int result = _mkdir(toCreate.c_str());
		#else
		int result = mkdir(toCreate.c_str(), S_IRWXU);
		#endif
		result = 0;
	}
	
	std::string VFS::getFullPath(const std::string &name, const std::string &mode)
	{
		for (size_t i = 0; i < dirList.size(); ++i)
		{
			std::string path(dirList[i]);
			path += '/';
			path += name;
			
			FILE *fp = fopen(path.c_str(), mode.c_str());
			if (fp)
			{
				fclose(fp);
				return path;
			}
		}
		return std::string("");
	}
}
